; =-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
; =                            P R O T O T Y P E S                            =
; =-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
_cpswsprintf                    Proto C : LPTSTR , : LPCTSTR, : VARARG


;   =-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
;   = Custom wsprintf prototype. Written by Bigboss from COPs.              =
;   =-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
;   = Supports: - %??d for decimal signed.                (16 numbers max.) =
;   =           - %s   for string display.                                  =
;   =           - %??u for decimal unsigned.              (16 numbers max.) =
;   =           - %??X for hexadecimal value.               (16 chars max.) =
;   =-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
;   = Note    : - ?? is optionnal.                                          =
;   =-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
;   = Entry   : - Like original wsprintf proto.                             =
;   =-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
;   = Returns : - eax -> Buffer size.                                       =
;   =-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
;   = Timing  : - Seems at least twice faster than wsprintfA.               =
;   =-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
_cpswsprintf                    Proc C  uses ebx ecx edx esi edi lpOut : LPTSTR, lpFmt : LPCTSTR , args : VARARG
 local          szHexa[010h] : byte
 local             bLeadChar : byte                                            ; Leading char ('0' or ' ')
 local             bMinusFlg : bool
  xor                       eax, eax
  mov                       edi, lpOut
  mov                       esi, lpFmt
  lea                       ebx, args
  .While                  TRUE
   mov                      al, [esi]
   inc                      esi
   .If                    al == '%'
    mov                     bMinusFlg, FALSE
    xor                     ecx, ecx
    mov                     al, [esi]
    inc                     esi
    .If                   al == '0'
     mov                    bLeadChar, '0'
    .Else
     mov                    bLeadChar, ' '
    .EndIf
    .While                (al >= '0' && al <= '9')
     imul                   ecx, 00Ah
     sub                    al, 030h
     add                    ecx, eax
     mov                    al, [esi]
     inc                    esi
    .EndW
    .If                   ecx > sizeof szHexa
     mov                    ecx, sizeof szHexa
    .EndIf
    .If                   al == 'd'
     ;  =-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
     ;  =                  Case signed decimal display                  =
     ;  =-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
     push                   esi
     push                   edi
     push                   ecx
     push                   ebx
     mov                    eax, [ebx]
     .If                  eax > 7FFFFFFFh
      neg                   eax
      mov                   bMinusFlg, TRUE
     .EndIf
     mov                    ebx, 00Ah
     mov                    ecx, sizeof szHexa
     lea                    edi, szHexa[000h + ecx - 001h]
     .Repeat
      xor                   edx, edx
      div                   ebx
      add                   dl, 030h
      mov                   [edi], dl
      dec                   edi
      .If                 !eax
       .Break
      .EndIf
     .UntilCXZ
     mov                    al, bLeadChar
     .Repeat
      mov                   [edi], al
      dec                   edi
     .UntilCXZ
     pop                    ebx
     pop                    ecx
     pop                    edi
     lea                    esi, szHexa[sizeof szHexa]
     mov                    edx, sizeof szHexa
     neg                    edx
     .While               TRUE
      mov                   al, [esi + edx]
      .If                 al != bLeadChar
       .Break
      .EndIf
      inc                   edx
     .EndW
     neg                    edx
     .If                  edx > ecx
      mov                   ecx, edx
     .EndIf
     sub                    esi, ecx
     .If                  bMinusFlg == TRUE
      mov                   al, [esi]
      .If                 al != bLeadChar
       inc                  ecx
       dec                  esi
       mov                  al, '-'
       mov                  [esi], al
      .ElseIf             bLeadChar == '0'
       mov                  al, '-'
       mov                  [esi], al
      .ElseIf             bLeadChar == ' '
       push                 esi
       lea                  esi, szHexa[sizeof szHexa]
       .While             TRUE
        mov                 al, [esi]
        .If               al == bLeadChar
         mov                al, '-'
         mov                [esi], al
         .Break
        .EndIf
        dec                 esi
       .EndW
       pop                  esi
      .EndIf
     .EndIf
     .Repeat
      mov                   al, [esi]
      inc                   esi
      mov                   [edi], al
      inc                   edi
     .UntilCXZ
     pop                    esi
     add                    ebx, 004h
    .ElseIf               al == 's'
     ;  =-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
     ;  =                      Case string display                      =
     ;  =-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
     push                   esi
     mov                    esi, [ebx]
     .While               TRUE
      mov                   al, [esi]
      inc                   esi
      .If                 !al
       .Break
      .EndIf
      mov                   [edi], al
      inc                   edi
     .EndW
     pop                    esi
     add                    ebx, 004h
    .ElseIf               al == 'u'
     ;  =-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
     ;  =                 Case unsigned decimal display                 =
     ;  =-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
     push                   esi
     push                   edi
     push                   ecx
     push                   ebx
     mov                    eax, [ebx]
     mov                    ebx, 00Ah
     mov                    ecx, sizeof szHexa
     lea                    edi, szHexa[000h + ecx - 001h]
     .Repeat
      xor                   edx, edx
      div                   ebx
      add                   dl, 030h
      mov                   [edi], dl
      dec                   edi
      .If                 !eax
       .Break
      .EndIf
     .UntilCXZ
     mov                    al, bLeadChar
     .Repeat
      mov                   [edi], al
      dec                   edi
     .UntilCXZ
     pop                    ebx
     pop                    ecx
     pop                    edi
     lea                    esi, szHexa[sizeof szHexa]
     mov                    edx, sizeof szHexa
     neg                    edx
     .While               TRUE
      mov                   al, [esi + edx]
      .If                 al != bLeadChar
       .Break
      .EndIf
      inc                   edx
     .EndW
     neg                    edx
     .If                  edx > ecx
      mov                   ecx, edx
     .EndIf
     sub                    esi, ecx
     .Repeat
      mov                   al, [esi]
      inc                   esi
      mov                   [edi], al
      inc                   edi
     .UntilCXZ
     pop                    esi
     add                    ebx, 004h
    .ElseIf               al == 'X'
     ;  =-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
     ;  =                   Case hexa-decimal display                   =
     ;  =-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
     push                   esi
     push                   edi
     push                   ecx
     mov                    eax, [ebx]
     mov                    ecx, sizeof szHexa
     lea                    edi, szHexa[sizeof szHexa - 001h]
     .Repeat
      push                  eax
      and                   eax, 00Fh
      .If                 al < 00Ah
       add                  al, 030h
      .Else
       add                  al, 037h
      .EndIf
      mov                   [edi], al
      dec                   edi
      pop                   eax
      shr                   eax, 004h
      .If                 !eax
       .Break
      .EndIf
     .UntilCXZ
     mov                    al, bLeadChar
     .Repeat
      mov                   [edi], al
      dec                   edi
     .UntilCXZ
     pop                    ecx
     pop                    edi
     lea                    esi, szHexa[sizeof szHexa]
     mov                    edx, sizeof szHexa
     neg                    edx
     .While               TRUE
      mov                   al, [esi + edx]
      .If                 al != bLeadChar
       .Break
      .EndIf
      inc                   edx
     .EndW
     neg                    edx
     .If                  edx > ecx
      mov                   ecx, edx
     .EndIf
     sub                    esi, ecx
     .Repeat
      mov                   al, [esi]
      inc                   esi
      mov                   [edi], al
      inc                   edi
     .UntilCXZ
     pop                    esi
     add                    ebx, 004h
    .EndIf
   .Else
     ;  =-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
     ;  =                       Case others cases                       =
     ;  =-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
    mov                     [edi], al
    inc                     edi
    .If                   !al
     .Break
    .EndIf
   .EndIf
  .EndW
  mov                       eax, edi
  sub                       eax, lpOut
  ret
_cpswsprintf                    EndP
